#include <algorithm>
#include <iostream>
#include <vector>
#include <list>
#include <ranges>

using namespace std;

using ll = long long;

const int N = 1e5 + 5;
int tree[N];

int f(int x) {
    return ((-x) & x);
}

void rev(int pos) {
    for (;pos < N; pos += f(pos)) {
        tree[pos]++;
    }
}

int get(int pos) {
    int ans = 0;
    for (;pos > 0; pos -= f(pos)) {
        ans += tree[pos];
    }

    return ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);

    int n, m, k;
    cin >> n >> m >> k;

    n--;
    m--;

    int dl = min(n / k, m / k);

    n -= dl * k;
    m -= dl * k;

    int ans = 0;
    ans += dl;

    if (n != 0 && m != 0) {
        int mn = min(n, m);

        ans++;

        n -= min(mn, k);
        m -= min(mn, k);
    }

    cout << (m + k - 1) / k + (n + k - 1) / k + ans;

    // int n;
    // cin >> n;
    //
    // if (n <= 1000) {
    //     vector<int> h(n);
    //     for (int i = 0; i < n; i++) {
    //         cin >> h[i];
    //     }
    //
    //     vector<vector<int>> v(n);
    //     for (int i = 0; i < n; i++) {
    //         v[i].push_back(h[i]);
    //     }
    //
    //     for (int i = 0; i < n - 1; i++) {
    //         int k;
    //         cin >> k;
    //
    //         int cnt = 0;
    //         int ind = -1;
    //         int ind2 = -1;
    //         for (int j = 0; j < n; j++) {
    //             if (v[j].size() != 0) {
    //                 cnt++;
    //             }
    //
    //             if (cnt == k && ind == -1) {
    //                 ind = j;
    //             }
    //
    //             if (cnt == k + 1 && ind2 == -1) {
    //                 ind2 = j;
    //             }
    //         }
    //
    //         for (auto j : v[ind2]) {
    //             v[ind].push_back(j);
    //         }
    //
    //         v[ind2].clear();
    //
    //         vector<int> pref_max(v[ind].size());
    //         vector<int> suff_max(v[ind].size());
    //
    //         pref_max[0] = v[ind].front();
    //         suff_max[v[ind].size() - 1] = v[ind].back();
    //
    //         for (int j = 1; j < v[ind].size(); j++) {
    //             pref_max[j] = max(v[ind][j], pref_max[j - 1]);
    //         }
    //
    //         for (int j = v[ind].size() - 2; j >=     0; j--) {
    //             suff_max[j] = max(v[ind][j], suff_max[j + 1]);
    //         }
    //
    //         ll sum = 0;
    //         for (int j = 0; j < v[ind].size(); j++) {
    //             sum += min(pref_max[j], suff_max[j]) - v[ind][j];
    //         }
    //
    //         cout << sum << '\n';
    //     }
    // } else {
    //
    // }

    return 0;
}