#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

using ll = long long;

const int N = 1e5 + 5;

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);

    int n, s;
    cin >> n >> s;

    vector<vector<int>> a(n);

    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;

        for (int j = 0; j < k; j++) {
            int c;
            cin >> c;

            a[i].push_back(c);
        }
    }

    vector<vector<bool>> dp(a[0].size() + 1, vector<bool>(s + 1));

    dp[0][0] = true;

    for (int i = 1; i <= a[0].size(); i++) {
        for (int j = 1; j <= s; j++) {
            dp[i][j] = dp[i - 1][j];

            if (j >= a[0][i - 1]) {
                dp[i][j] = dp[i][j] || dp[i - 1][j - a[0][i - 1]];
            }
        }
    }

    if (dp[a[0].size()][s]) {
        cout << "Yes\n";

        int sum = s;
        int start = a[0].size();

        vector<int> ans;

        while (start > 0 && sum > 0) {
            if (dp[start - 1][sum]) {
                start--;
                continue;
            }

            ans.push_back(start);
            sum -= a[0][start - 1];
            start--;
        }

        sort(ans.begin(), ans.end());

        cout << ans.size() << '\n';

        for (auto i : ans) {
            cout << i << '\n';
        }
    }
    else {
        cout << "No";
    }


    return 0;
}