#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

using ll = long long;

const int N = 105;

int n, m, k;

bool has[N][N];

bool used[N][N];

int ans = 0;

vector<pair<int, int>> var{ {-1, 0}, {1, 0}, {0, -1}, {0, 1} };

void dfs(int x, int y, int path, int cnt) {
    if (x == 1 && y == 1 && path == 2 * n + 2 * m - 4 && cnt == k) {
        ans++;
        return;
    }

    for (auto i : var) {
        if (i.first + x >= 1 && i.first + x <= n && i.second + y >= 1 && i.second + y <= m && !used[i.first + x][i.second + y]) {
            used[i.first + x][i.second + y] = true;

            dfs(x + i.first, y + i.second, path + 1, (cnt + (has[i.first + x][i.second + y])));

            used[i.first + x][i.second + y] = false;

            
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);

    cin >> n >> m >> k;

    for (int i = 0; i < k; i++) {
        int x, y;
        cin >> x >> y;

        has[x][y] = true;
    }

    dfs(1, 1, 0, 0);

    cout << ans;


    

    return 0;
}