#include <iostream>
#include <vector>

using namespace std;

using ll = unsigned long long;

ll count(string s) {
    if (s == "0") return 0;
    if (s == "1") return 0;
    if (s == "2") return 1;
    if (s == "3") return 2;
    if (s == "4") return 2;
    if (s == "5") return 3;
    if (s == "6") return 3;
    if (s == "7") return 4;
    if (s == "8") return 4;
    if (s == "9") return 4;

    vector<int> elems{2, 3, 5, 7};

    vector<bool> pref(s.size() + 1);
    vector<bool> small(s.size() + 1);
    pref[0] = true;

    ll ans = 0;

    for (ll i = 1; i < s.size(); i++) {
        ans += i * 4ll;
    }


    bool smaller = false;
    small[0] = false;
    for (int i = 1; i <= s.size(); i++) {
        if (smaller) {
            pref[i] = true;
        } else {
            if (pref[i - 1] && (s[i - 1] - '0') >= 1) {
                pref[i] = true;

                if ((s[i - 1] - '0') > 1) {
                    smaller = true;
                }
            }
        }

        small[i] = smaller;
    }


    vector<bool> suff(s.size() + 1);
    suff[0] = true;
    for (int j = 1; j <= s.size(); j++) {
        if (s[s.size() - j] > '1') {
            suff[j] = true;
        } else if (s[s.size() - j] == '1') {
            suff[j] = suff[j - 1];
        }
    }

    // ans += 4;
    for (auto i : elems) {
        for (int j = 0; j < s.size(); j++) {
            if ((i <= (s[j] - '0') && pref[j] || i > (s[j] - '0') && small[j]) && suff[s.size() - j - 1]) {
                ans++;
            }
        }
    }

    return ans;
}


int main() {
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);

    string l, r;
    cin >> l >> r;

    ll res2 = count(l);
    ll res1 = count(r);


   ll fin = res1 - res2;

    int cnt = 0;
    char m = 0;
    for (int i = 0; i < l.size(); i++) {
        if (l[i] == '1') {
            cnt++;
        } else {
            m = l[i];
        }
    }

    if (cnt == l.size() - 1 && (m == '2' || m == '3' || m == '5' || m == '7')) {
        fin++;
    }

    cout << fin;

    return 0;
}