#include <algorithm>
#include <iostream>
#include <vector>
#include <list>
#include <ranges>
#include <set>

using namespace std;

using ll = long long;

const int N = 200 + 5;

const ll MOD = 1e9 + 7;

ll dp[N][4];

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);

    int n;
    cin >> n;

    vector<int> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }

    if (v[0] == 0) {
        dp[1][0] = 1;
    } else if (v[0] == 1) {
        dp[1][1] = 1;
        dp[1][2] = 1;
    } else {
        dp[1][3] = 1;
    }

    for (int i = 2; i <= n; i++) {
        for (int j = 0; j < 4; j++) {
            for (int k = 0; k < 4; k++) {
                int sum = 0;

                if (k == 1) {
                    sum++;
                }

                if (j == 1 || j == 2) {
                    sum++;
                }

                if (j == 3) {
                    sum += 2;
                }

                if (sum == v[i - 1]) {
                    dp[i][j] = (dp[i][j] + dp[i - 1][k]) % MOD;
                }
            }
        }
    }

    int ans = 0;
    for (int i = 0; i < 4; i++) {
        ans = (ans + dp[n][i]) % MOD;
    }

    cout << ans;

    return 0;
}