#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

using ll = long long;

#define int long long

const int N = 3e5 + 5;

ll pref_min[N];
ll suff_min[N];

ll pref_sum[N];

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);

    int n, k;
    cin >> n >> k;

    vector<ll> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    if (k == 1) {
        cout << 0;
        return 0;
    }

    pref_min[0] = 1e9;

    for (int i = 1; i <= n; i++) {
        pref_min[i] = min(pref_min[i - 1], a[i - 1]);
    }

    suff_min[n] = 1e9;
    for (int i = n - 1; i >= 0; i--) {
        suff_min[i] = min(suff_min[i + 1], a[i]);
    }

    pref_sum[0] = 0;
    for (int i = 1; i <= n; i++) {
        pref_sum[i] = pref_sum[i - 1] + a[i - 1];
    }

    ll sz2 = n - k + 1;
    ll ans = 0;

    for (int sz = 1; sz <= sz2; sz++) {
        for (int i = sz - 1; i < n; i++) {
            ll mn = 1e9;

            mn = min(mn, pref_min[i - sz + 1]);
            mn = min(mn, suff_min[i + 1]);

            ans = max(ans, pref_sum[i + 1] - pref_sum[i - sz + 1] - mn);
        }
    }

    cout << ans;

    return 0;
}